//
//  FADMainModuleViewController.swift
//  FADSelfieTest
//
//  Created by Juan Carlos Pérez on 2/3/19.
//  Copyright (c) 2019 Juan Carlos Pérez. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

protocol FADMainModuleDisplayLogic: class
{
  func displaySomething(viewModel: FADMainModule.Something.ViewModel)
    
    func configProgressView (config: [[String: Any]])
    func hideProgressView(hidden: Bool)
    func callModule()
    func finishCurrentModule()
}

class FADMainModuleViewController: UIViewController, FADMainModuleDisplayLogic
{
    
    @IBOutlet weak var progressViewContainer : UIView!
    @IBOutlet weak var progressViewHeightConstraint : NSLayoutConstraint!
    @IBOutlet weak var progressView : UIStackView!
    @IBOutlet weak var contentView : UIView!
    
    var navController : UINavigationController?
    
    fileprivate var isProgressHidden = false
    fileprivate var menuItemIndex = 0
    
  var interactor: FADMainModuleBusinessLogic?
  var router: (NSObjectProtocol & FADMainModuleRoutingLogic & FADMainModuleDataPassing)?

  // MARK: Object lifecycle
  
  override init(nibName nibNameOrNil: String?, bundle nibBundleOrNil: Bundle?)
  {
    super.init(nibName: nibNameOrNil, bundle: nibBundleOrNil)
    setup()
  }
  
  required init?(coder aDecoder: NSCoder)
  {
    super.init(coder: aDecoder)
    setup()
  }
  
  // MARK: Setup
  
  private func setup()
  {
    let viewController = self
    let interactor = FADMainModuleInteractor()
    let presenter = FADMainModulePresenter()
    let router = FADMainModuleRouter()
    viewController.interactor = interactor
    viewController.router = router
    interactor.presenter = presenter
    presenter.viewController = viewController
    router.viewController = viewController
    router.dataStore = interactor
  }
  
  // MARK: Routing
  
  override func prepare(for segue: UIStoryboardSegue, sender: Any?)
  {
    if let scene = segue.identifier {
      let selector = NSSelectorFromString("routeTo\(scene)WithSegue:")
      if let router = router, router.responds(to: selector) {
        router.perform(selector, with: segue)
      }
    }
  }
  
  // MARK: View lifecycle
  
  override func viewDidLoad()
  {
    super.viewDidLoad()
    
    doSomething()
    router?.routeToManager(segue: nil)
    
  }
  
  // MARK: Do something
  
  //@IBOutlet weak var nameTextField: UITextField!
  
  func doSomething()
  {
    let request = FADMainModule.Something.Request()
    interactor?.doSomething(request: request)
  }
  
  func displaySomething(viewModel: FADMainModule.Something.ViewModel)
  {
    //nameTextField.text = viewModel.name
  }
    

    func configProgressView (config: [[String: Any]]) {
        self.menuItemIndex = 0
        
        for pos in progressView.subviews {
            //progressView.removeArrangedSubview(pos)
            pos.removeFromSuperview()
        }
        
        
        for pos in 0..<config.count {
            let view: FADProgressViewItem = FADProgressViewItem()
            view.itemStatusType = .inactive
            let dictItem = config[pos]
            view.lblTitle.text = dictItem["title"] as? String ?? ""
            view.delegate = dictItem["handler"] as? ProgressItemDelegate
            
            //let showModule = dictItem["show"] as? Bool ?? false
            //if let _ = dictItem["handler"] as? ProgressItemDelegate, showModule {
                progressView.addArrangedSubview(view)
            //}
        }
        
      
        
    }
    
    func callModule(){
        if let module = progressView.subviews[self.menuItemIndex] as? FADProgressViewItem{
            self.menuItemIndex += 1
            module.updateStatus(status: .inProgress)
            module.btnCallModule.sendActions(for: .touchUpInside)
        }
    }
    
    func finishCurrentModule(){
        if let module = progressView.subviews[self.menuItemIndex-1] as? FADProgressViewItem{
            module.updateStatus(status: .finished)
        }
    }
    
    
    
    func hideProgressView(hidden: Bool) {
        
        UIView.animate(withDuration: 0.5, animations: {
            self.progressViewHeightConstraint.constant = self.isProgressHidden ? 50 : 0
            self.progressViewContainer.isHidden = false
            self.view.layoutIfNeeded()
        }) { (success) in
            self.progressViewContainer.isHidden = !self.isProgressHidden
            self.isProgressHidden = !self.isProgressHidden
        }
        
    }

    
    @IBAction func btnBackAction(_ sender : Any){
        navController?.popViewController(animated: true)
    }
    
}
